# Blender add-on. Import in User Settings/Addons.

import bpy
import os.path
import sys
from math import pi

def render_pass(init_z_rot_radians, z_rot_frac_radians, length_scale, zoom):
	global ttd_object, company, livery, zoom_name, real_dimensions
	
	ttd_object.scale = [zoom, zoom * length_scale, zoom]
	ttd_object.rotation_euler.z = init_z_rot_radians

	i = 0
	while  i < 2 * pi / z_rot_frac_radians:
		bpy.ops.render.render()
		# Saves into ../../gfx/$(company)/$(blend_name)_$(vehlength)/$(livery)_32bpp_$(zoom)_$(angle).png"
		bpy.data.images['Render Result'].save_render(os.path.join('..', '..', 'gfx', company, bpy.path.display_name_from_filepath(bpy.data.filepath) + '_' + str(round(real_dimensions * 4)), livery + '_32bpp_' + zoom_name + '_' +  str(round(ttd_object.rotation_euler.z * 180 / pi)) + 'deg.png'))
	
		ttd_object.rotation_euler.z += z_rot_frac_radians
		i += 1
			
	ttd_object.scale = [1.0, 1.0, 1.0]
	ttd_object.rotation_euler.z = 0

company = sys.argv[8]
livery = sys.argv[9]
zoom_name = sys.argv[10]
	
bpy.context.scene.render.image_settings.file_format = 'PNG'
ttd_object = bpy.data.objects.get("ttd_object")

if ttd_object == None:
	'Rendering error: ttd_object does not exist'
	'(file: ' + bpy.data.filepath + ')'
	SystemExit

if ttd_object.type != 'MESH':
	'Rendering error: ttd_object is not a mesh object'
	'(file: ' + bpy.data.filepath + ')'
	SystemExit
	
real_dimensions = ttd_object.dimensions.y # needed because of directional scaling

# Standard horizontal/vertical views
render_pass(0, pi / 2, 1.0, 1.0)

# Standard diagonal views
render_pass(pi / 4, pi / 2, 0.75 * 32.0 / 34.0, 1.0)
	
# Extra CETS angles, sorted from most horizontal to most vertical
# Angle values found by binary search, scaling by comparison of side lengths
# Angles kept positive for better ordering
render_pass(pi * 8.38125 / 180, pi, 57.0 / 63.0, 1.0)
render_pass(pi * (1 - 8.38125 / 180), pi, 57.0 / 63.0, 1.0)
render_pass(pi * 30.9375 / 180, pi, 40.0 / 55.0, 1.0)
render_pass(pi * (1 - 30.9375 / 180), pi, 40.0 / 55.0, 1.0)
render_pass(pi * 56.25 / 180, pi, 25.0 / 35.0, 1.0)
render_pass(pi * (1 - 56.25 / 180), pi, 25.0 / 35.0, 1.0)
render_pass(pi * 80.390625 / 180, pi, 0.8425, 1.0)
render_pass(pi * (1 - 80.390625 / 180), pi, 0.8425, 1.0)
