#!/bin/bash -E
# (always exit on error)
    # Shell script utility to read a file line line.
    # Once line is read it can be process in processLine() function
    # You can call script as follows, to read myfile.txt:
    # ./readline myfile.txt
    # Following example will read line from standard input device aka keyboard:
    # ./readline
    # -----------------------------------------------
    # Copyright (c) 2005 nixCraft <http://cyberciti.biz/fb/>
    # This script is licensed under GNU GPL version 2.0 or above
    # -------------------------------------------------------------------------
    # This script is part of nixCraft shell script collection (NSSC)
    # Visit http://bash.cyberciti.biz/ for more information.
    # -------------------------------------------------------------------------
    # Modified by oberhuemer 2012
     
    # User define Function (UDF)
    processLine(){
    # just echo them, but you may need to customize it according to your need
    # for example, F1 will store first field of $line, see readline2 script
    # for more examples
 
    # $1 is the table line

    convert $(echo $2) -fuzz 0% -fill $(echo $1 | awk -F'\t' '{ print $2 }') -opaque $(echo $1 | awk -F'\t' '{ print $1 }') PNG32:$(echo $2)

    #rm -rf $2
    #mv $2.tmp $2
    }
     
    ### Main script stars here ###
    # Store table and file name
    #FILE=""
     
    # Make sure we get file name as command line argument
    # Else read it from standard input device

    #if [ "$1" == "" ]; then
    #table="/dev/stdin"
    #else
    table="$1"	
    # make sure file exist and readable
    #if [ ! -f $table ]; then
    #echo "$table : color translation table does not exist!"
    #exit 1
    #elif [ ! -r $table ]; then
    #echo "$table: can not read color translation table!"
    #exit 2
    #fi
    #fi
    #if [ "$2" == "" ]; then
    #image="/dev/stdin"
    #else
    image="$2"	
    # make sure file exist and readable
    #if [ ! -f $image ]; then
    #echo "$image : image file does not exist!"
    #exit 1
    #elif [ ! -r $image ]; then
    #echo "$image: can not read image file!"
    #exit 2
    #fi
    #fi
    #echo "Replacing colors in image $image."
    # read table using the file descriptors
     
    # Set loop separator to end of line
    BAKIFS=$IFS
    IFS=$(echo -en "\n\b")
    exec 3<&0
    exec 0<"$table" # The table file, $2 is the image file
    while read -r line
    do
    # use $line variable to process line in processLine() function
    processLine $line $image
    done
    exec 0<&3
     
    # restore $IFS which was used to determine what the field separators are
    IFS=$BAKIFS
    exit 0

